//+------------------------------------------------------------------+
//|                                                SymbolCopyier.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property script_show_inputs

#include "Symbol.mqh" // https://www.mql5.com/en/code/18855
#include <TradeAlgorithms.mqh> CIsNewBar newbar;
input  int Offset=-24 *1; // Offset in hours

#define HOUR 3600
long id;
const SYMBOL SYMB(_Symbol+"_1");//(string) fabs(Offset)); // Created a character
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   if(SYMB.IsExist()) // If Created
     {
      SYMB.CloneProperties(); // copied properties
      //SYMB.CloneHistory(_Symbol);
      int rates_total=5000;//(int) SeriesInfoInteger(_Symbol,PERIOD_M1,SERIES_BARS_COUNT);
      Print(rates_total);
      MqlRates Rates[];

      // Displaced the time of bars 
      for(int i=CopyRates(_Symbol,PERIOD_M1,0,rates_total,Rates)-1; i>=0; i--)
        {
         MqlTick Ticks[];
         int vv=CopyTicks(_Symbol,Ticks,COPY_TICKS_INFO,ulong(Rates[i].time)*1000,uint(Rates[i].tick_volume));
         //Print(vv);
         //Print(Rates[i].time);
         Rates[i].time+=Offset*HOUR;
         for(int ii=vv-1; ii>=0; ii--)
           {
            //Print(Ticks[ii].time);
            Ticks[ii].time+=Offset*HOUR;
            //Print(Ticks[ii].time);
            //Ticks[ii].time_msc=long(Ticks[ii].time);
           }
         SYMB.CloneTicks(Ticks);

         //break;

        }

      // SYMB.CloneTicks (Ticks);

      //// Recorded offset bars and included a SYMBol in the Market
      if(SYMB.CloneRates(Rates)>0 && SYMB.On()) //Print("opened");
        {
         id=ChartOpen(SYMB.Name,PERIOD_CURRENT); // Opened the chart of the new SYMBol
         ChartSetInteger(id,CHART_AUTOSCROLL,1);
         Print(ChartSetInteger(id,CHART_SHIFT,0,ChartGetInteger(ChartID(),CHART_SHIFT)));
        }
     }
//if(SYMB.On()) //Print("opened");
//     {id =ChartOpen(SYMB.Name,PERIOD_CURRENT); // Opened the chart of the new SYMBol
//     ChartSetInteger(id,CHART_AUTOSCROLL,1);
//     }

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  if(SYMB.IsExist()&& newbar.IsNewBar(_Symbol,_Period))
  {
   MqlRates Rates[];

// Displaced the time of bars 
   for(int i=CopyRates(_Symbol,PERIOD_M1,0,2,Rates)-1; i>=0; i--)
     {
      MqlTick Ticks[];
      int vv=CopyTicks(_Symbol,Ticks,COPY_TICKS_INFO,ulong(Rates[i].time)*1000,uint(Rates[i].tick_volume));

      Rates[i].time+=Offset*HOUR;
      for(int ii=vv-1; ii>=0; ii--)
        {
         Ticks[ii].time+=Offset*HOUR;
        }
      //CustomTicksReplace(SYMB.Name,Ticks[vv-1].time_msc,Ticks[0].time_msc,Ticks);
      SYMB.CloneTicks(Ticks);
     }
    // CustomRatesUpdate(SYMB.Name,Rates);
    CustomRatesReplace(SYMB.Name,Rates[ArraySize(Rates)-1].time,Rates[0].time,Rates);
     //SYMB.CloneRates(Rates);
}
   MqlRates Rates[];

// Displaced the time of bars 
   for(int i=CopyRates(_Symbol,PERIOD_M1,0,1,Rates)-1; i>=0; i--)
     {
      MqlTick Ticks[];
      int vv=CopyTicks(_Symbol,Ticks,COPY_TICKS_INFO,ulong(Rates[i].time)*1000,uint(Rates[i].tick_volume));

      Rates[i].time+=Offset*HOUR;
      for(int ii=vv-1; ii>=0; ii--)
        {
         Ticks[ii].time+=Offset*HOUR;
        }
      //CustomTicksReplace(SYMB.Name,Ticks[vv-1].time_msc,Ticks[0].time_msc,Ticks);
      SYMB.CloneTicks(Ticks);
     }
     //CustomRatesUpdate(SYMB.Name,Rates);
     CustomRatesReplace(SYMB.Name,Rates[ArraySize(Rates)-1].time,Rates[0].time,Rates);
    //SYMB.CloneRates(Rates);
return(rates_total);
}
//+------------------------------------------------------------------+
void OnDeinit(const int r)
  {
   if(id!=0)ChartClose(id);
  }
//+------------------------------------------------------------------+
